<template>
  <section class="room-description">
    <div class="room-description__top-row">
      <h4 class="room-description__title">
        Описание
      </h4>

      <div class="room-description__arrow"
           v-if="isMobile"
           @click="$emit('mobileToTop')"
      >
        <icon-small-arrow />
      </div>
    </div>

    <accordion :short-description="shortDescription"
               :long-description="longDescription"/>

    <div class="table-wrapper" v-if="schedule.length">
      <table class="table count-table">
        <tbody>
        <tr>
          <td>Дни недели</td>
          <td>Время</td>
          <td>Посетители</td>
          <td class="count-table__header-price">Цена за 1 час</td>
        </tr>
        <tr v-for="(schedule, index) in schedule"
            :key="index">
          <td class="count-table__weekday-cell">
            <span v-for="(day, index) of schedule.rules.weekdays"
                  :key="index">
              {{ `${getWeekDay(day)}${schedule.rules.weekdays.length === index + 1 ? '' : ','}` }}
            </span>
          </td>
          <td class="count-table__time-cell">
            <span>
              {{ `${schedule.rules.from} - ${schedule.rules.to}` }}
            </span>
          </td>
          <td class="count-table__visitors-cell">
            <span v-if="schedule.rules.visitors !== null">
              {{ `${schedule.rules.visitors.min} - ${schedule.rules.visitors.max}` }}
            </span>
            <span v-else>
              &infin;
            </span>
<!--            <span v-if="schedule.rules.visitors !== null">-->
<!--              {{ `${schedule.rules.visitors.min} - ${schedule.rules.visitors.max}` }}-->
<!--            </span>-->
<!--            <span v-else>-->
<!--              &infin;-->
<!--            </span>-->
          </td>
          <td class="count-table__price-cell">
            <span class="">{{schedule.price | rubCurrency}}</span>
          </td>
        </tr>
        </tbody>

      </table>
    </div>

    <div class="room-description__list">
      <div class="room-description__list-item"
           v-for="item in description" :key="item.label">
        <div class="room-description__list-wrapper">
          <span class="room-description__list-label">{{ item.label }}</span>
        </div>
        <span class="room-description__list-value" v-html="item.value"></span>
      </div>
    </div>
  </section>
</template>

<script>
  import IconSmallArrow from './icons/IconSmallArrow';
  import Accordion from './Accordion';

  import {weekDays} from '../assets/js/helpers/consts'

  export default {
    name: 'RoomDescription',
    components: {
      Accordion,
      IconSmallArrow
    },
    props: {
      description: {
        type: Array,
        required: true,
      },

      shortDescription: {
        type: String,
        required: true
      },

      longDescription: {
        type: String,
        default: ''
      },
      schedule: {
        type: Array
      }
    },
    computed: {
      isMobile() {
        return this.$store.state.isMobile;
      }
    },
    methods: {
      getWeekDay(day) {
        return weekDays[day === 7 ? 0 : day].short
      }
    }
  }
</script>

<style lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .room-description {
    &__top-row {
      display: flex;
      align-items: center;
      justify-content: space-between;
      margin-bottom: rem(20);
    }

    &__arrow {
      @include to-top-arrow;
    }

    &__title {
      @include h4;
    }

    &__description {
      @include p2;

      margin-bottom: rem(24);
      line-height: rem(22);
    }

    &__list {
      margin-top: rem(30);
    }

    &__list-item {
      display: flex;

      @media (max-width: $mobile-width) {
        justify-content: space-between;
      }

      & + & {
        margin-top: rem(20);
      }

      &::after {
        content: '';

        position: absolute;
        top: rem(18);
        left: 0;
        right: 0;

        width: 100%;
        height: 1px;
        background: #DCE2EF;
      }
    }

    &__list-wrapper {
      flex: 0 0 rem(300);
      width: rem(300);

      @media (max-width: $mobile-width) {
        flex: 0 0 rem(160);
        width: rem(160);
      }
    }

    &__list-label,
    &__list-value {
      @include p1();

      position: relative;
      z-index: 1;

      font-weight: 400;
      background: $gray;
    }

    &__list-label {
      display: inline-flex;
      padding-right: rem(30);
      margin-right: rem(100);

      color: rgba($black, .6);
      white-space: nowrap;

      @media (max-width: $mobile-width) {
        padding-right: rem(20);
      }
    }

    &__list-value {
      flex: 1;
      padding-left: rem(30);

      @media (max-width: $mobile-width) {
        flex: 0 0 auto;
        padding-left: rem(20);
        max-width: calc(100% - 10.5rem);
        text-align: right;
      }
    }

    .table-wrapper {
      @include table;
      margin-top: rem(30);
    }

    .count-table {
      td {
        padding-top: rem(22);
        padding-bottom: rem(22);

        font-weight: 400 !important;
        border-width: rem(1);
      }
      tbody tr:first-child td {
        border-bottom-color: $green;
      }
      tbody tr:last-child td {
        border-bottom: none;
      }

      &__header-price,
      &__price-cell {
        text-align: right;
      }

      &__price-cell {
        width: rem(256);
      }

      &__time-cell {
        width: rem(290);
      }
    }

  }
</style>
